/**
******************************************************************************
* @file   		  tcp_demo.c
* @author  			WIZnet Software Team
* @version 			V1.1
* @date    			2017-08-01
* @brief   		  TCP ʾ
* @attention  
******************************************************************************
* @company  	  WIZnetڰ
* @website  		www.iwiznet.cn
******************************************************************************

**/

#include <stdio.h>
#include <string.h>
#include "tcp_demo.h"
#include "W5500_conf.h"
#include "w5500.h"
#include "led.h"
#include "socket.h"
#include "edpkit.h"
#include "utility.h"
#include "timer.h"
#include "DHT11.h"

extern uint8 txsize[];
extern uint8 rxsize[];

EdpPacket* send_pkg;        /*Эṹ*/
uint8 buff[2048];				                              	         /*һ2KBĻ*/
#define   DEVICEID   "11777774"                                  /*豸ID*/   
#define   APIKEY     "iDki1hLWnsvmZkXoAcKKc0xB=PE="              /*豸APIKEY*/


#define   DEVICEID_   "17581403"                                  /*豸ID*/   
#define   APIKEY_     "QpAbDad4r76PtRpt0o1St=jNlVI="              /*豸APIKEY*/

uint8 Txbuffer[1024]={0};
uint8 temp_rh[2];//p[0]ʪ p[1]¶

char send_buf[1024];
uint8 buffer[2048];
uint32 edp_count=0;
unsigned char ricv_buf[1024];
unsigned char  cmd_buf[1024];
uint16_t size = 0;
volatile unsigned char  rcv_cmd_start=0;
volatile unsigned int   usart2_cmd_len=0;
uint8 xintiao[2]={0xc0,0x00};


/**
*@brief		TCP Serverػʾ
*@param		
*@return	
*/
void do_tcp_server_1(void)
{	
	uint16 len=0;  
	switch(getSn_SR(SOCK_TCPS))											            	/*ȡsocket״̬*/
	{
		case SOCK_CLOSED:													                  /*socketڹر״̬*/
			socket(SOCK_TCPS ,Sn_MR_TCP,local_port,Sn_MR_ND);	        /*socket*/
		  break;     
    
		case SOCK_INIT:														                  /*socketѳʼ״̬*/
			listen(SOCK_TCPS);												                /*socket*/
		  break;
		
		case SOCK_ESTABLISHED:												              /*socketӽ״̬*/
		
			if(getSn_IR(SOCK_TCPS) & Sn_IR_CON)
			{
				setSn_IR(SOCK_TCPS, Sn_IR_CON);								          /*жϱ־λ*/
			}
			len=getSn_RX_RSR(SOCK_TCPS);									            /*lenΪѽݵĳ*/
			if(len>0)
			{
				recv(SOCK_TCPS,buff,len);								              	/*Client*/
				buff[len]=0x00; 											                  /*ַ*/
				printf("%s\r\n",buff);
				send(SOCK_TCPS,buff,len);									              /*Client*/
		  }
		  break;
		
		case SOCK_CLOSE_WAIT:												                /*socketڵȴر״̬*/
			close(SOCK_TCPS);
		  break;
	}
}

/**
*@brief		TCP Clientػʾ
*@param		
*@return	
*/
static uint8 EDP_State=0;// 0: ״̬ 1״η  2ȴ״̬  һӷһ
static char EDP_flag=0; //0豸ʧ  1豸ɹ
void do_tcp_client_1(void)
{	
	
  uint16 i;
	while(1)
	{
	switch(getSn_SR(SOCK_TCPC))								  				         /*ȡsocket״̬*/
	{
		case SOCK_CLOSED:											        		         /*socketڹر״̬*/
			socket(SOCK_TCPC,Sn_MR_TCP,local_port++,Sn_MR_ND);
		  break;
		
	case SOCK_INIT:													        	         /*socketڳʼ״̬*/
		
			connect(SOCK_TCPC,remote_ip,remote_port); 
			/*socketӷ*/ 
		  break;
		
		case SOCK_ESTABLISHED: 												             /*socketӽ״̬*/
	
			if(getSn_IR(SOCK_TCPC) & Sn_IR_CON)
			{
				setSn_IR(SOCK_TCPC, Sn_IR_CON); 							         /*жϱ־λ*/
			}

					switch(EDP_State)
					{
						case 0:
											if(EDP_flag==0)
										{
											DeleteBuffer(&send_pkg);
											send_pkg = PacketConnect1(DEVICEID,APIKEY);      /*oneNET*/
											printf("!\r\n");
											memcpy(buffer,send_pkg->_data,send_pkg->_write_pos);   
//                      printf("%s\r\n",send_pkg->_data);											
											send(SOCK_TCPC,buffer,send_pkg->_write_pos);							/*W5500*/
											delay_ms(500);
											DeleteBuffer(&send_pkg);
											delay_ms(700);
											printf("Уݷ!\r\n");
											size = getSn_RX_RSR(SOCK_TCPC);
											if(size>0)
											{
													recv(0, ricv_buf, 4);						             /*Server*/	
													if((ricv_buf[0]==0x20)&&(ricv_buf[3]==0x00))  /*ӳɹϢͷ0x20״̬0x00*/
														{ 
															EDP_flag=1;
															EDP_State=1;
															printf("Уɹ豸ɹ!\r\n");
														}
												  else if(ricv_buf[0]==0x40)              /*0x40ʾƷIDȨʧ*/
														{
															ricv_Clear();
															EDP_flag=0;
															EDP_State=0;
															close(SOCK_TCPC);/*ִ,رն˿!*/
															printf("ƷIDȨʧ,رն˿!\r\n");
														}
											}
										} 
						break;
						case 1:
									{
									  GetSendBuf();	           /*ȡLEDƵ״̬дEDPתݵĸʽ*/
										printf("뷢\r\n");
										DeleteBuffer(&send_pkg);  /*ɾṹڴй©*/
										send_pkg = PacketSavedataSimpleString(DEVICEID,send_buf);/*ݰɣתݵϢ塢Ϣʣ೤ȡ־λԼ͸ʽLED״ֵ̬*/
										memcpy(buffer,send_pkg->_data,send_pkg->_write_pos);	
										printf("\r\n");	
										send(SOCK_TCPC,buffer,send_pkg->_write_pos);							/*W5500*/
										DeleteBuffer(&send_pkg);
										delay_ms(700);
				            size = getSn_RX_RSR(SOCK_TCPC);    /*ȡֵ*/
										if(size>0)
											{
												recv(0, ricv_buf, size);						/*Server*/
												if(ricv_buf[0]==0x80)        /*ݷ,ƽ̨յзظ豸Եһݻ0x80*/
														{
														  EDP_State=2;
															printf("ݷͳɹ\r\n");
														}
												else if(ricv_buf[0]==0x40)    /*ӹر*/
														{
														  EDP_flag=0;
															EDP_State=0;
															close(SOCK_TCPC);/*ִ,رն˿!*/
															printf("ִ,رն˿!\r\n");
														}
												
											}
									}
							break;
							case 2:
										{	
											if(edp_count==120) /*һϴһ,500ms*120=60s=1 mine*/
											{
												printf("edp_count=%d\r\n",edp_count);
									    	EDP_State=1;
										  	edp_count=0;
											}
									    size = getSn_RX_RSR(SOCK_TCPC);   /*յ*/
											if(size>0)
											{
						
												printf("յ!\r\n");
											  recv(0, ricv_buf, size);						/*Server*/	
												for(i=0;i<size;i++)
														{ 
															printf("0x%x ",ricv_buf[i]);
														}
														
														printf("\r\n");
												if(ricv_buf[0]==0xa0 | ricv_buf[0]==0x30)   /*ݵĵһֽ*/
												{
												   printf("յ!\r\n");
												   OneNet_App();     /**/
											
													
												}
												else if(ricv_buf[0]==0x40)
														{
														
															EDP_flag=0;
															EDP_State=0;
															close(SOCK_TCPC);  /*ִ,رն˿!*/
															printf("ִ,رն˿!  %d  \r\n",edp_count);
														}
							         }
									
							       }	
								break;
								default:
                break;
		}
	
		  break;
			
		case SOCK_CLOSE_WAIT: 											    	         /*socketڵȴر״̬*/
			close(SOCK_TCPC);
		  break;
	

	}
}
}
void GetSendBuf(void)
{
		char text[25] = {0};
			
  	LED_GetValue();

		memset(send_buf,0,1024);   /*buff*/
		
		 /*edpתtype=5*/
		strcat(send_buf, ",;");	  /*Ϣзָָ*/
		strcat(send_buf, "LED_0_statu,");  /*ϢID*/
		sprintf(text,"%d",value0);
		strcat(send_buf, text);          /*Ϣֵ*/
		strcat(send_buf, ";");    /*Ϣָ*/
		
		strcat(send_buf, "LED_1_statu,");
		sprintf(text,"%d",value1);
		strcat(send_buf, text);
		strcat(send_buf, ";");

		strcat(send_buf, "LED_2_statu,");
		sprintf(text,"%d",value2);
		strcat(send_buf, text);
		strcat(send_buf, ";");

		strcat(send_buf, "LED_3_statu,");
		sprintf(text,"%d",value3);
		strcat(send_buf, text);
		strcat(send_buf, ";");	

}
void OneNet_App(void)  //жϽƽ̨͹ִжӦĲ
{
    if(((char)(ricv_buf[size-2])=='1')&&((char)(ricv_buf[size-1])=='O'))  //Լƽ̨"1o"Ϊһӡ!
		{
				printf("LED0!\r\n");
        LED0_ON;		
     }
		if(((char)(ricv_buf[size-2])=='1')&&((char)(ricv_buf[size-1])=='C'))  //Լƽ̨"1c"Ϊһӡ!
		{
				printf("LED0!\r\n");	
		  	LED0_OFF;
  	}
		if(((char)(ricv_buf[size-2])=='2')&&((char)(ricv_buf[size-1])=='O'))  //Լƽ̨"2o"Ϊһӡ!
		{
				printf("LED1!\r\n");
        LED1_ON;		
     }
		if(((char)(ricv_buf[size-2])=='2')&&((char)(ricv_buf[size-1])=='C'))  //Լƽ̨"2c"Ϊһӡ!
		{
				printf("LED1!\r\n");	
		  	LED1_OFF;
  	}
		if(((char)(ricv_buf[size-2])=='3')&&((char)(ricv_buf[size-1])=='O'))  //Լƽ̨"3o"Ϊһӡ!
		{
				printf("LED2!\r\n");
        LED2_ON;		
     }
		if(((char)(ricv_buf[size-2])=='3')&&((char)(ricv_buf[size-1])=='C'))  //Լƽ̨"3c"Ϊһӡ!
		{
				printf("LED2!\r\n");	
		  	LED2_OFF;
  	}
		if(((char)(ricv_buf[size-2])=='4')&&((char)(ricv_buf[size-1])=='O'))  //Լƽ̨"4o"Ϊһӡ!
		{
				printf("LED3!\r\n");
        LED3_ON;		
     }
		if(((char)(ricv_buf[size-2])=='4')&&((char)(ricv_buf[size-1])=='C'))  //Լƽ̨"4c"Ϊһӡ!
		{
				printf("LED3!\r\n");	
		  	LED3_OFF;
  	}
	
	

}
void ricv_Clear(void)
{

	memset(ricv_buf, 0, sizeof(ricv_buf));
}


void GetSendBuf_(void)
{
		char text[25] = {0};
			
    
		memset(send_buf,0,1024);   /*buff*/
		if( DHT11_GetValue(temp_rh))
	  {
		
		 /*edpתtype=5*/
	   strcat(send_buf, ",;");	  /*Ϣзָָ*/
		 strcat(send_buf, "temperature,");  /*ϢID*/
		 sprintf(text,"%d",temp_rh[1]);
		 strcat(send_buf, text);          /*Ϣֵ*/
		 strcat(send_buf, ";");    /*Ϣָ*/
		
		 strcat(send_buf, "humidity,");
		 sprintf(text,"%d",temp_rh[0]);
		 strcat(send_buf, text);
		 strcat(send_buf, ";");	
		}
}


void do_tcp_client_2(void)
{
  
    while(1)
		{
      switch(getSn_SR(SOCK_HUMTEM))
      {
				case SOCK_CLOSED:											        		         /*socketڹر״̬*/
			     socket(SOCK_HUMTEM,Sn_MR_TCP,local_port++,Sn_MR_ND);
		       break;
        case SOCK_INIT:
           connect(SOCK_HUMTEM, remote_ip ,remote_port);
           break;
        case SOCK_ESTABLISHED:
          if(getSn_IR(SOCK_HUMTEM) & Sn_IR_CON)
          {
            setSn_IR(SOCK_HUMTEM, Sn_IR_CON);
          }					
					switch(EDP_State)
					{
						case 0:
										if(EDP_flag==0)
										{
											DeleteBuffer(&send_pkg);
											send_pkg = PacketConnect1(DEVICEID_,APIKEY_);      /*oneNET*/
											printf("!\r\n");
											memcpy(buffer,send_pkg->_data,send_pkg->_write_pos);   
//                      printf("%s\r\n",send_pkg->_data);											
											send(SOCK_HUMTEM,buffer,send_pkg->_write_pos);							/*W5500*/
											delay_ms(500);
											DeleteBuffer(&send_pkg);
											delay_ms(700);
											printf("Уݷ!\r\n");
											size = getSn_RX_RSR(SOCK_HUMTEM);
											if(size>0)
											{
													recv(1, ricv_buf, 4);						             /*Server*/	
													if((ricv_buf[0]==0x20)&&(ricv_buf[3]==0x00))  /*ӳɹϢͷ0x20״̬0x00*/
														{ 
															EDP_flag=1;
															EDP_State=1;
															printf("Уɹ豸ɹ!\r\n");
														}
												  else if(ricv_buf[0]==0x40)              /*0x40ʾƷIDȨʧ*/
														{
															ricv_Clear();
															EDP_flag=0;
															EDP_State=0;
															close(SOCK_HUMTEM);/*ִ,رն˿!*/
															printf("ƷIDȨʧ,رն˿!\r\n");
														}
											}
										} 
						break;
						case 1:
									{
									    GetSendBuf_();	           /*ȡʪֵдEDPתݵĸʽ*/
										  printf("뷢\r\n");
										  DeleteBuffer(&send_pkg);  /*ɾṹڴй©*/
										  send_pkg = PacketSavedataSimpleString(DEVICEID_,send_buf);/*ݰɣתݵϢ塢Ϣʣ೤ȡ־λԼ͸ʽʪֵ*/
										  memcpy(buffer,send_pkg->_data,send_pkg->_write_pos);	
										  printf("\r\n");	
										  send(SOCK_HUMTEM,buffer,send_pkg->_write_pos);							/*W5500*/
										  DeleteBuffer(&send_pkg);
										  delay_ms(700);
				              size = getSn_RX_RSR(SOCK_HUMTEM);    /*ȡֵ*/
										 if(size>0)
										 {
												recv(1, ricv_buf, size);						/*Server*/
												if(ricv_buf[0]==0x80)        /*ݷ,ƽ̨յַظ豸Եһݻ0x80*/
													{
														 EDP_State=2;
														printf("ݷͳɹ\r\n");
													}
											 else if(ricv_buf[0]==0x40)    /*ӹر*/
													{
														EDP_flag=0;
														EDP_State=0;
														close(SOCK_HUMTEM);/*ִ,رն˿!*/
														printf("ִ,رն˿!\r\n");
													}
												
										}
										
									}
							break;
							case 2:
										{	
											if(edp_count==120) /*һϴһ,500ms*120=60s=1 mine*/
											{
												printf("edp_count=%d\r\n",edp_count);
									    	EDP_State=1;
										  	edp_count=0;
											}
							       }	
								break;
								default:
                break;
		      }
	
		   break;
       case SOCK_CLOSE_WAIT: 											    	         /*socketڵȴر״̬*/
			  close(SOCK_HUMTEM);
		   break;
       default:
       break;
   }   
 }

}




